function love.load()
   math.randomseed(os.time())
   math.random(); math.random(); math.random()
   score = 0
   font = love.graphics.newFont(36)
   font2 = love.graphics.newFont(48)
   font3 = love.graphics.newFont(24)
   music = love.audio.newSource("sounds/technoloop.wav")
   music:setLooping(true)
   music:play()
   scoreup = love.audio.newSource("sounds/scoreup.wav")
   scoreup:setLooping(false)
   whendead = love.audio.newSource("sounds/dead.wav")
   whendead:setLooping(false)
   ismusic = true
   isfx = true
   newGame()
   start = true
end

function love.update(dt)
    if not dead and not start then
    ratio = player.r / maxradius
    ratio = 1 - ratio
    if love.keyboard.isDown("s") then
        player.r = player.r - 1
        if player.r < minradius then
            player.r = 10
        end
    end
    if love.keyboard.isDown("w") then
        player.r = player.r + 1
        if player.r > maxradius then
            player.r = 60
            moving = false
        end
    end
    if vel.x < 0 then
        vel.x = -maxvel * ratio
    elseif vel.x > 0 then
        vel.x = maxvel * ratio
    end
    if vel.y < 0 then
        vel.y = -maxvel * ratio
    elseif vel.y > 0 then
        vel.y = maxvel * ratio
    end
    if moving then
        player.x = player.x + vel.x * dt
        player.y = player.y + vel.y * dt
    end
    if player.x + player.r > 800 or player.x - player.r < 0 then
        if isfx then
            whendead:play()
        end
        dead = true
    end
    if player.y + player.r > 600 or player.y - player.r < 0 then
        if isfx then
            whendead:play()
        end
        dead = true
    end
    for _,tiles in ipairs(tilecorners) do
        local x,y = tiles[1],tiles[2]
        if (player.y - y)^2 + (player.x - x)^2 < (player.r + 16)^2 then 
            if isfx then
                whendead:play()
            end
            dead = true
        end
    end
    for i = 1,360,1 do
        local cx,cy=player.x + player.r * math.cos(math.rad(i)),player.y + player.r * math.sin(math.rad(i))
        if cx > exit.x and cx < exit.x + exit.w and cy > exit.y and cy < exit.y + exit.h then
            if isfx then
                scoreup:play()
            end
            score = score + 1
            newGame()
        end
    end
    end
end

function love.draw()
    if not start then
    for _,tiles in ipairs(tilecorners) do
        local x,y = tiles[1],tiles[2]
        love.graphics.setColor(255, 0, 0)
        love.graphics.circle("fill", x, y, 16, 16)
    end
    love.graphics.setColor(255, 255, 0)
    love.graphics.rectangle("fill", exit.x, exit.y, exit.w, exit.h)
    if not dead then
        love.graphics.setColor(0, 255, 0)
    else
        love.graphics.setColor(255, 0, 0)
    end
    love.graphics.circle("fill", player.x, player.y, player.r)
    love.graphics.setColor(255, 255, 255)
    love.graphics.setFont(font3)
    if ismusic then
        love.graphics.print("(M)usic: on ", 640, 30)
    else
        love.graphics.print("(M)usic: off", 640, 30)
    end
    if isfx then
        love.graphics.print("(F)x: on ", 640, 56)
    else
        love.graphics.print("(F)x: off", 640, 56)
    end
    love.graphics.setFont(font)
    love.graphics.print(score, 720, 100) 
    if dead then
        message = love.graphics.newText(font, "Your score is "..score)
        love.graphics.draw(message, 400 - message:getWidth() / 2, 300)
    end
    else
        title = love.graphics.newText(font2, "Resized")
        love.graphics.setColor(0, 255 ,0)
        love.graphics.draw(title, 400 - title:getWidth() / 2, 220)
        love.graphics.setColor(255, 255, 0)
        message1 = love.graphics.newText(font3, "Reach the yellow box. Don't touch the red circles.")
        message2 = love.graphics.newText(font3, "At maximum size, you stop.")
        message3 = love.graphics.newText(font3, "Bigger: slower, smaller: faster.")
        message4 = love.graphics.newText(font3, "W, S to resize. Arrow keys to move.")
        message5 = love.graphics.newText(font3, "Press Space to start, Escape to quit.")
        love.graphics.draw(message1, 400 - message1:getWidth() / 2, 300)
        love.graphics.draw(message2, 400 - message2:getWidth() / 2, 340)
        love.graphics.draw(message3, 400 - message3:getWidth() / 2, 380)
        love.graphics.draw(message4, 400 - message4:getWidth() / 2, 420)
        love.graphics.draw(message5, 400 - message5:getWidth() / 2, 460)
    end
end

function love.keypressed(key)
    if key == "escape" then
        if start then
            love.event.quit()
        else
            start = true
        end
    end
    if key == "space" and start then
        start = false
        score = 0
        newGame()
    end
    if key == "space" and dead then
        score = 0
        newGame()
    end
    if key == "m" then
        ismusic = not ismusic
        if ismusic then
            music:play()
        else
            music:stop()
        end
    end
    if key == "f" then
        isfx = not isfx
    end
    if key == "right" then
        vel.x = maxvel * ratio
        vel.y = 0
        moving = true
    end
    if key == "left" then
        vel.x = -maxvel * ratio
        vel.y = 0
        moving = true
    end
    if key == "up" then
        vel.x = 0
        vel.y = -maxvel * ratio
        moving = true
    end
    if key == "down" then
        vel.x = 0
        vel.y = maxvel * ratio
        moving = true
    end
end

function newGame()
   dead = false
   moving = false
   vel = {}
   vel.x = 60
   vel.y = 60
   maxradius = 60
   minradius = 10
   maxvel = 200
   ratio = 0
   tilecorners = {}
   player = {}
   player.x = 60
   player.y = 60
   player.r = 30
   exit = {}
   exit.x = 750
   exit.y = 550
   exit.w = 50
   exit.h = 50
   if score%2 == 0 then
       for i=1,30 do
           local x,y = math.random(16, 784),math.random(136,534)
           tilecorners[i] = {x, y}
       end
   else
       for i=1,30 do
           local x,y = math.random(136, 734),math.random(16,584)
           tilecorners[i] = {x, y}
       end
    end
end
